#!/bin/perl
#
   # Programma per aprire il file pippo.txt, leggerlo,
   # stamparlo a schermo e infine chiuderlo.

   # Nome del file da leggere
   $file = 'pippo.txt';
   # Apre il file 
   #(INFO --> rappresenta il legame con il file)
   #($file --> rappresenta solo il nome del file)
   open(INFO, $file);
   # Per poter leggere il contenuto del file 
   #necessario inseriro in una struttura dati opportuna.
   #Per farlo scegliamo un array. Questa assegnazione
   #memorizza in ogli cella dell'array una riga del file.
   @righe = <INFO>;
   # Chiude il file
   close(INFO);
   
   # Visualizza tutto il contenuto dell'array
   print "Visualizzo tutto il contenuto del file\n";   
   print @righe;
   print "\n";      
   
   #Visualizza solo la prima riga dell'array
   print "Stampo solo la prima riga\n ".$righe[0]."\n\n";
   
   #Visualizza solo l'ultima riga dell'array
   print "Stampo solo l'ultima riga\n ".$righe[@righe-1]."\n\n";   

#E' presente un errore. In particolare dopo la stampa della prima
#riga ho un fine linea in pi. Questo  dovuto al fatto che 
#la variabile $riga[0] contiene anche il fine linea.
#Per eliminare questa anomalia devo rimuovere i fine linea dalle 
#righe dell'array

#Eliminazione del finelinea dalle linee del file
chomp(@righe);

print "Adesso l'anomalia  scomparsa\n";

   #Visualizza solo la prima riga dell'array
   print "Stampo solo la prima riga\n ".$righe[0]."\n\n";
   
   #Visualizza solo l'ultima riga dell'array
   print "Stampo solo l'ultima riga\n ".$righe[@righe-1]."\n\n";   


print "\n";

#Metodi di accesso ai file

$file_2 = "prova.txt";

   # Apre in lettura
   open(READ, $file);
   @read = <READ>;   
   close(READ);
   print "@read\n";

   # Apre in scrittura
   open(WRITE, ">$file_2");
   print WRITE "Scrivo questa riga nel file di prova.\n";
   close(WRITE);
   
   # Apre per appendere l'uscita
   open(APPEND, ">>$file_2");
   print APPEND "Inserisco una nuova riga nel file di prova";
   close(APPEND);
   
   # Altro modo per aprire in lettura
   open(READ_2, "<$file_2");
   @read_2 = <READ_2>;
   print "@read_2\n";


#Nota sul "foreach":
#Per prendere in considerazione una alla volta 
#ogni riga di un array o di un altro contenitore 
#di tipo lista (come ad esempio le diverse righe 
#in un file di testo) in Perl si usa il comando foreach

foreach $i (@read){
	@parole = split(/ /, $i);
	foreach $k (@parole){
	    print "$k\n";
	}
}
